(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/material/datepicker'), require('@angular/material/form-field'), require('@angular/material/input')) :
    typeof define === 'function' && define.amd ? define('mat-datepicker-time-header', ['exports', '@angular/core', '@angular/forms', '@angular/material/datepicker', '@angular/material/form-field', '@angular/material/input'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['mat-datepicker-time-header'] = {}, global.ng.core, global.ng.forms, global.ng.material.datepicker, global.ng.material.formField, global.ng.material.input));
}(this, (function (exports, core, forms, datepicker, formField, input) { 'use strict';

    var MAT_DATEPICKER_TIME_CONTROL_NAME = new core.InjectionToken('custom form control name for datepicker header input');
    function _handleUserSelection(event) {
        var selection = this._model.selection;
        var value = event.value;
        var isRange = selection instanceof datepicker.DateRange;
        // If we're selecting a range and we have a selection strategy, always pass the value through
        // there. Otherwise don't assign null values to the model, unless we're selecting a range.
        // A null value when picking a range means that the user cancelled the selection (e.g. by
        // pressing escape), whereas when selecting a single value it means that the value didn't
        // change. This isn't very intuitive, but it's here for backwards-compatibility.
        if (isRange && this._rangeSelectionStrategy) {
            var newSelection = this._rangeSelectionStrategy.selectionFinished(value, selection, event.event);
            this._model.updateSelection(newSelection, this);
        }
        else if (value && (isRange ||
            !this._dateAdapter.sameDate(value, selection))) {
            this._model.add(value);
        }
        // if ((!this._model || this._model.isComplete()) && !this.disableAutoClose) {
        //     this.datepicker.close();
        // }
    }

    var MatDatepickerTimeHeaderComponent = /** @class */ (function () {
        function MatDatepickerTimeHeaderComponent(parentFormDir, timeInputControlName, matDatepickerContent, calendar, changeDetectorRef) {
            this.parentFormDir = parentFormDir;
            this.timeInputControlName = timeInputControlName;
            this.matDatepickerContent = matDatepickerContent;
            this.calendar = calendar;
            // rangepicker not supported (no place in heafer)
            this.throwIfRange();
            // by default, after selecting a date, the picker closes automaticaly. We are overriding it to allow time selection
            this.disableAutoClose();
            //this.calendar.stateChanges.subscribe(() => changeDetectorRef.markForCheck());
        }
        Object.defineProperty(MatDatepickerTimeHeaderComponent.prototype, "isRange", {
            get: function () {
                return this.calendar.selected instanceof datepicker.DateRange;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MatDatepickerTimeHeaderComponent.prototype, "timeControl", {
            get: function () {
                return this.parentFormDir.form.get(this.timeInputControlName || 'time');
            },
            enumerable: false,
            configurable: true
        });
        MatDatepickerTimeHeaderComponent.prototype.throwIfRange = function () {
            if (this.isRange) {
                throw ('mat-datepicker-time-header-component is not yet supported for date-range picker');
            }
        };
        MatDatepickerTimeHeaderComponent.prototype.disableAutoClose = function () {
            //; (this.matDatepickerContent as any).disableAutoClose = true;
            //MatDatepickerContent.prototype._handleUserSelection = _handleUserSelection;
            this.matDatepickerContent._handleUserSelection = _handleUserSelection;
        };
        return MatDatepickerTimeHeaderComponent;
    }());
    MatDatepickerTimeHeaderComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'mat-datepicker-time-header',
                    template: "<mat-calendar-header>\r\n    <mat-form-field appearance=\"outline\">\r\n        <mat-label>time</mat-label>\r\n        <input type=\"time\" [formControl]=\"timeControl\" matInput>\r\n    </mat-form-field>\r\n</mat-calendar-header>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: forms.ControlContainer, useExisting: forms.FormGroupDirective }],
                    styles: [".mat-form-field{max-width:90px;font-size:.9em}:host::ng-deep.mat-form-field-wrapper{margin-bottom:-1.25em}:host::ng-deep .mat-form-field-flex>.mat-form-field-infix{padding:.4em 0!important}:host::ng-deep .mat-form-field-label-wrapper{top:-1.4em}:host::ng-deep .mat-form-field-appearance-outline.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-label{transform:translateY(-1.1em) scale(.75);width:133.33333%}input[type=time]::-webkit-calendar-picker-indicator{background:none;display:none}"]
                },] }
    ];
    MatDatepickerTimeHeaderComponent.ctorParameters = function () { return [
        { type: forms.FormGroupDirective },
        { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [MAT_DATEPICKER_TIME_CONTROL_NAME,] }, { type: core.Optional }] },
        { type: datepicker.MatDatepickerContent },
        { type: datepicker.MatCalendar, decorators: [{ type: core.Inject, args: [core.forwardRef(function () { return datepicker.MatCalendar; }),] }] },
        { type: core.ChangeDetectorRef }
    ]; };

    var MatDatepickerTimeHeaderModule = /** @class */ (function () {
        function MatDatepickerTimeHeaderModule() {
        }
        return MatDatepickerTimeHeaderModule;
    }());
    MatDatepickerTimeHeaderModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [MatDatepickerTimeHeaderComponent],
                    imports: [
                        forms.ReactiveFormsModule,
                        datepicker.MatDatepickerModule,
                        formField.MatFormFieldModule,
                        input.MatInputModule
                    ],
                    exports: [MatDatepickerTimeHeaderComponent]
                },] }
    ];

    /*
     * Public API Surface of mat-datepicker-time-header
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.MAT_DATEPICKER_TIME_CONTROL_NAME = MAT_DATEPICKER_TIME_CONTROL_NAME;
    exports.MatDatepickerTimeHeaderComponent = MatDatepickerTimeHeaderComponent;
    exports.MatDatepickerTimeHeaderModule = MatDatepickerTimeHeaderModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=mat-datepicker-time-header.umd.js.map
